// Generated by CoffeeScript 1.3.1
(function() {
  var CommonLogger, Logger, SysLogger, config, fs, logFile,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  CommonLogger = require('underscore.logger').constructor;

  SysLogger = require('ain2');

  fs = require('fs');

  config = {};

  logFile = void 0;

  exports.setConfig = function(config_) {
    var ain2;
    config = Object.create(config_);
    config.level = Math.max(0, CommonLogger.levels.indexOf(config_.level));
    if (config_.file) {
      logFile = fs.createWriteStream(config_.file, {
        flags: 'a'
      });
    }
    if ((config_.syslog != null) && Object.keys(config_.syslog).length > 0) {
      ain2 = new SysLogger();
      ain2.set({
        tag: 'buddycloud',
        facility: 'daemon',
        transport: 'file'
      });
      if (config_.syslog.hostname) {
        ain2.set({
          transport: 'udp',
          hostname: config_.syslog.hostname
        });
      }
      if (config_.syslog.port) {
        return ain2.set({
          port: config_.syslog.port
        });
      }
    }
  };

  Logger = (function(_super) {

    __extends(Logger, _super);

    Logger.name = 'Logger';

    function Logger(module) {
      this.module = module;
      Logger.__super__.constructor.call(this, config);
    }

    Logger.prototype._log = function(level, args) {
      if (args[0] && typeof args[0] !== 'string') {
        args[0] = args[0].toString();
      }
      return Logger.__super__._log.apply(this, arguments);
    };

    Logger.prototype.format = function(date, level, message) {
      return "[" + (date.toUTCString()) + "] " + CommonLogger.levels[level] + " [" + this.module + "] " + message;
    };

    Logger.prototype.out = function(message) {
      if (config.stdout) {
        console.log(message);
      }
      if (logFile) {
        logFile.write("" + message + "\n");
      }
      if ((config.syslog != null) && Object.keys(config.syslog).length > 0) {
        return typeof ain2 !== "undefined" && ain2 !== null ? typeof ain2['info'] === "function" ? ain2['info'](message) : void 0 : void 0;
      }
    };

    return Logger;

  })(CommonLogger);

  exports.makeLogger = function(module) {
    return new Logger(module);
  };

}).call(this);
