// Generated by CoffeeScript 1.3.1
(function() {
  var AuthorizeSubscriber, CreateNode, DiscoverRequest, ManageNodeAffiliations, ManageNodeConfiguration, ManageNodeSubscriptions, NS, Publish, PubsubOwnerRequest, PubsubRequest, REQUESTS, RSM, Request, RetractItems, RetrieveItems, RetrieveNodeAffiliations, RetrieveNodeConfiguration, RetrieveNodeSubscriptions, RetrieveUserSubscriptions, Subscribe, Unsubscribe, async, errors, forms, logger, xmpp,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  logger = require('../logger').makeLogger('xmpp/pubsub_client');

  xmpp = require('node-xmpp');

  async = require('async');

  NS = require('./ns');

  errors = require('../errors');

  forms = require('./forms');

  RSM = require('./rsm');

  Request = (function() {

    Request.name = 'Request';

    function Request(conn, opts, cb) {
      var iq,
        _this = this;
      this.opts = opts;
      this.myJid = conn.jid;
      iq = this.requestIq().root();
      iq.attrs.to = this.opts.jid;
      conn.sendIq(iq, function(err, replyStanza) {
        var result;
        if (err) {
          return cb(err);
        }
        result = null;
        err = null;
        try {
          result = _this.decodeReply(replyStanza);
        } catch (e) {
          logger.error(e.stack);
          err = e;
        }
        return cb(err, result);
      });
    }

    Request.prototype.requestIq = function() {
      throw new TypeError("Unimplemented request");
    };

    Request.prototype.decodeReply = function(stanza) {
      throw new TypeError("Unimplemented reply");
    };

    return Request;

  })();

  /*
  # XEP-0030: Service Discovery
  */


  DiscoverRequest = (function(_super) {

    __extends(DiscoverRequest, _super);

    DiscoverRequest.name = 'DiscoverRequest';

    function DiscoverRequest() {
      return DiscoverRequest.__super__.constructor.apply(this, arguments);
    }

    DiscoverRequest.prototype.xmlns = void 0;

    DiscoverRequest.prototype.requestIq = function() {
      var queryAttrs;
      queryAttrs = {
        xmlns: this.xmlns
      };
      if (this.opts.node != null) {
        queryAttrs.node = this.opts.node;
      }
      return new xmpp.Element('iq', {
        type: 'get'
      }).c('query', queryAttrs);
    };

    DiscoverRequest.prototype.decodeReply = function(stanza) {
      var child, queryEl, _i, _len, _ref;
      this.results = [];
      queryEl = stanza != null ? stanza.getChild('query', this.xmlns) : void 0;
      if (queryEl) {
        _ref = queryEl.children;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          child = _ref[_i];
          if (typeof child !== 'string') {
            this.decodeReplyEl(child);
          }
        }
      }
      return this.results;
    };

    DiscoverRequest.prototype.decodeReplyEl = function(el) {};

    return DiscoverRequest;

  })(Request);

  exports.DiscoverItems = (function(_super) {

    __extends(DiscoverItems, _super);

    DiscoverItems.name = 'DiscoverItems';

    function DiscoverItems() {
      return DiscoverItems.__super__.constructor.apply(this, arguments);
    }

    DiscoverItems.prototype.xmlns = NS.DISCO_ITEMS;

    DiscoverItems.prototype.decodeReplyEl = function(el) {
      var result;
      if (el.is('item', this.xmlns) && (el.attrs.jid != null)) {
        result = {
          jid: el.attrs.jid
        };
        if (el.attrs.node) {
          result.node = el.attrs.node;
        }
        return this.results.push(result);
      }
    };

    return DiscoverItems;

  })(DiscoverRequest);

  exports.DiscoverInfo = (function(_super) {

    __extends(DiscoverInfo, _super);

    DiscoverInfo.name = 'DiscoverInfo';

    function DiscoverInfo() {
      return DiscoverInfo.__super__.constructor.apply(this, arguments);
    }

    DiscoverInfo.prototype.xmlns = NS.DISCO_INFO;

    DiscoverInfo.prototype.decodeReplyEl = function(el) {
      var form, _base, _base1, _base2;
      if ((_base = this.results).identities == null) {
        _base.identities = [];
      }
      if ((_base1 = this.results).features == null) {
        _base1.features = [];
      }
      if ((_base2 = this.results).config == null) {
        _base2.config = null;
      }
      if (el.is('identity', this.xmlns)) {
        return this.results.identities.push({
          name: el.attrs.name,
          category: el.attrs.category,
          type: el.attrs.type
        });
      } else if (el.is('feature', this.xmlns)) {
        return this.results.features.push(el.attrs["var"]);
      } else if (el.is('x', NS.DATA)) {
        form = forms.fromXml(el);
        if (form.getFormType() === NS.PUBSUB_META_DATA) {
          return this.results.config = forms.formToConfig(form);
        }
      }
    };

    return DiscoverInfo;

  })(DiscoverRequest);

  PubsubRequest = (function(_super) {

    __extends(PubsubRequest, _super);

    PubsubRequest.name = 'PubsubRequest';

    function PubsubRequest() {
      return PubsubRequest.__super__.constructor.apply(this, arguments);
    }

    PubsubRequest.prototype.xmlns = NS.PUBSUB;

    PubsubRequest.prototype.requestIq = function() {
      var actorEl, pubsubEl, _base;
      pubsubEl = new xmpp.Element('iq', {
        type: this.iqType()
      }).c('pubsub', {
        xmlns: this.xmlns
      });
      pubsubEl.cnode(this.pubsubChild().root());
      if (this.opts.actor) {
        actorEl = pubsubEl.c('actor', {
          xmlns: NS.BUDDYCLOUD_V1
        });
        if ((_base = actorEl.attrs).type == null) {
          _base.type = this.opts.actorType;
        }
        actorEl.t(this.opts.actor);
      }
      if (this.opts.rsm) {
        pubsubEl.cnode(this.opts.rsm.toXml());
      }
      return pubsubEl.up();
    };

    PubsubRequest.prototype.iqType = function() {
      throw new TypeError("Unimplemented request");
    };

    PubsubRequest.prototype.pubsubChild = function() {
      throw new TypeError("Unimplemented reply");
    };

    PubsubRequest.prototype.decodeReply = function(stanza) {
      var child, pubsubEl, _i, _len, _ref;
      this.results = [];
      pubsubEl = stanza != null ? stanza.getChild('pubsub', this.xmlns) : void 0;
      if (pubsubEl != null) {
        if (this.decodeReplyEl != null) {
          _ref = pubsubEl.children;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            child = _ref[_i];
            if (typeof child !== 'string') {
              this.decodeReplyEl(child);
            }
          }
        }
        this.results.rsm = RSM.fromXml(pubsubEl.getChild('set', NS.RSM), true);
      }
      return this.results;
    };

    return PubsubRequest;

  })(Request);

  CreateNode = (function(_super) {

    __extends(CreateNode, _super);

    CreateNode.name = 'CreateNode';

    function CreateNode() {
      return CreateNode.__super__.constructor.apply(this, arguments);
    }

    CreateNode.prototype.iqType = function() {
      return 'set';
    };

    CreateNode.prototype.pubsubChild = function() {
      return new xmpp.Element('create', {
        node: this.opts.node
      });
    };

    return CreateNode;

  })(PubsubRequest);

  Publish = (function(_super) {

    __extends(Publish, _super);

    Publish.name = 'Publish';

    function Publish() {
      return Publish.__super__.constructor.apply(this, arguments);
    }

    Publish.prototype.iqType = function() {
      return 'set';
    };

    Publish.prototype.pubsubChild = function() {
      var item, itemAttrs, publishEl, _i, _len, _ref;
      publishEl = new xmpp.Element('publish', {
        node: this.opts.node
      });
      _ref = this.opts.items;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        item = _ref[_i];
        itemAttrs = {};
        if (itemAttrs.id == null) {
          itemAttrs.id = item.id;
        }
        publishEl.c('item', itemAttrs).cnode(item.el);
      }
      return publishEl;
    };

    return Publish;

  })(PubsubRequest);

  RetractItems = (function(_super) {

    __extends(RetractItems, _super);

    RetractItems.name = 'RetractItems';

    function RetractItems() {
      return RetractItems.__super__.constructor.apply(this, arguments);
    }

    RetractItems.prototype.iqType = function() {
      return 'set';
    };

    RetractItems.prototype.pubsubChild = function() {
      var item, publishEl, _i, _len, _ref;
      publishEl = new xmpp.Element('retract', {
        node: this.opts.node
      });
      _ref = this.opts.items;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        item = _ref[_i];
        publishEl.c('item', {
          id: item.id
        });
      }
      return publishEl;
    };

    return RetractItems;

  })(PubsubRequest);

  Subscribe = (function(_super) {

    __extends(Subscribe, _super);

    Subscribe.name = 'Subscribe';

    function Subscribe() {
      return Subscribe.__super__.constructor.apply(this, arguments);
    }

    Subscribe.prototype.iqType = function() {
      return 'set';
    };

    Subscribe.prototype.pubsubChild = function() {
      return new xmpp.Element('subscribe', {
        node: this.opts.node,
        jid: this.opts.actor
      });
    };

    Subscribe.prototype.decodeReplyEl = function(el) {
      var _base, _base1, _ref;
      if (el.is('subscription', this.xmlns) && el.attrs.node === this.opts.node) {
        if ((_base = this.results).user == null) {
          _base.user = el.attrs.jid || this.opts.actor;
        }
        return (_ref = (_base1 = this.results).subscription) != null ? _ref : _base1.subscription = el.attrs.subscription || 'subscribed';
      }
    };

    Subscribe.prototype.localPushData = function() {
      if (this.results.subscription === 'subscribed') {
        return [
          {
            type: 'subscription',
            node: this.opts.node,
            user: this.results.user,
            listener: this.opts.sender,
            subscription: this.results.subscription
          }
        ];
      } else {
        return [];
      }
    };

    return Subscribe;

  })(PubsubRequest);

  Unsubscribe = (function(_super) {

    __extends(Unsubscribe, _super);

    Unsubscribe.name = 'Unsubscribe';

    function Unsubscribe() {
      return Unsubscribe.__super__.constructor.apply(this, arguments);
    }

    Unsubscribe.prototype.iqType = function() {
      return 'set';
    };

    Unsubscribe.prototype.pubsubChild = function() {
      return new xmpp.Element('unsubscribe', {
        node: this.opts.node
      });
    };

    Unsubscribe.prototype.localPushData = function() {
      return [
        {
          type: 'subscription',
          node: this.opts.node,
          user: this.opts.actor,
          subscription: 'none'
        }
      ];
    };

    return Unsubscribe;

  })(PubsubRequest);

  RetrieveItems = (function(_super) {

    __extends(RetrieveItems, _super);

    RetrieveItems.name = 'RetrieveItems';

    function RetrieveItems() {
      return RetrieveItems.__super__.constructor.apply(this, arguments);
    }

    RetrieveItems.prototype.iqType = function() {
      return 'get';
    };

    RetrieveItems.prototype.pubsubChild = function() {
      return new xmpp.Element('items', {
        node: this.opts.node
      });
    };

    RetrieveItems.prototype.decodeReplyEl = function(el) {
      var itemEl, _i, _len, _ref, _results;
      if (el.is('items', this.xmlns)) {
        _ref = el.getChildren('item');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          itemEl = _ref[_i];
          _results.push(this.results.push({
            id: itemEl.attrs.id,
            el: itemEl.children.filter(function(child) {
              return child !== 'string';
            })[0]
          }));
        }
        return _results;
      }
    };

    return RetrieveItems;

  })(PubsubRequest);

  RetrieveUserSubscriptions = (function(_super) {

    __extends(RetrieveUserSubscriptions, _super);

    RetrieveUserSubscriptions.name = 'RetrieveUserSubscriptions';

    function RetrieveUserSubscriptions() {
      return RetrieveUserSubscriptions.__super__.constructor.apply(this, arguments);
    }

    RetrieveUserSubscriptions.prototype.iqType = function() {
      return 'get';
    };

    RetrieveUserSubscriptions.prototype.pubsubChild = function() {
      return new xmpp.Element('subscriptions');
    };

    RetrieveUserSubscriptions.prototype.decodeReplyEl = function(el) {
      var subscription, subscriptionEl, _i, _len, _ref, _results;
      if (el.is('subscriptions', this.xmlns)) {
        _ref = el.getChildren('subscription');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          subscriptionEl = _ref[_i];
          subscription = {};
          if (subscription.user == null) {
            subscription.user = subscriptionEl.attrs.jid;
          }
          if (subscription.subscription == null) {
            subscription.subscription = subscriptionEl.attrs.subscription;
          }
          if (subscription.node == null) {
            subscription.node = subscriptionEl.attrs.node;
          }
          _results.push(this.results.push(subscription));
        }
        return _results;
      }
    };

    return RetrieveUserSubscriptions;

  })(PubsubRequest);

  PubsubOwnerRequest = (function(_super) {

    __extends(PubsubOwnerRequest, _super);

    PubsubOwnerRequest.name = 'PubsubOwnerRequest';

    function PubsubOwnerRequest() {
      return PubsubOwnerRequest.__super__.constructor.apply(this, arguments);
    }

    PubsubOwnerRequest.prototype.xmlns = NS.PUBSUB_OWNER;

    return PubsubOwnerRequest;

  })(PubsubRequest);

  RetrieveNodeSubscriptions = (function(_super) {

    __extends(RetrieveNodeSubscriptions, _super);

    RetrieveNodeSubscriptions.name = 'RetrieveNodeSubscriptions';

    function RetrieveNodeSubscriptions() {
      return RetrieveNodeSubscriptions.__super__.constructor.apply(this, arguments);
    }

    RetrieveNodeSubscriptions.prototype.iqType = function() {
      return 'get';
    };

    RetrieveNodeSubscriptions.prototype.pubsubChild = function() {
      return new xmpp.Element('subscriptions', {
        node: this.opts.node
      });
    };

    RetrieveNodeSubscriptions.prototype.decodeReplyEl = function(el) {
      var subscriptionEl, _i, _len, _ref, _results;
      if (el.is('subscriptions', this.xmlns)) {
        _ref = el.getChildren('subscription');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          subscriptionEl = _ref[_i];
          _results.push(this.results.push({
            user: subscriptionEl.attrs.jid,
            subscription: subscriptionEl.attrs.subscription
          }));
        }
        return _results;
      }
    };

    return RetrieveNodeSubscriptions;

  })(PubsubOwnerRequest);

  RetrieveNodeAffiliations = (function(_super) {

    __extends(RetrieveNodeAffiliations, _super);

    RetrieveNodeAffiliations.name = 'RetrieveNodeAffiliations';

    function RetrieveNodeAffiliations() {
      return RetrieveNodeAffiliations.__super__.constructor.apply(this, arguments);
    }

    RetrieveNodeAffiliations.prototype.iqType = function() {
      return 'get';
    };

    RetrieveNodeAffiliations.prototype.pubsubChild = function() {
      return new xmpp.Element('affiliations', {
        node: this.opts.node
      });
    };

    RetrieveNodeAffiliations.prototype.decodeReplyEl = function(el) {
      var affiliationEl, _i, _len, _ref, _results;
      if (el.is('affiliations', this.xmlns)) {
        _ref = el.getChildren('affiliation');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          affiliationEl = _ref[_i];
          _results.push(this.results.push({
            user: affiliationEl.attrs.jid,
            affiliation: affiliationEl.attrs.affiliation
          }));
        }
        return _results;
      }
    };

    return RetrieveNodeAffiliations;

  })(PubsubOwnerRequest);

  ManageNodeSubscriptions = (function(_super) {

    __extends(ManageNodeSubscriptions, _super);

    ManageNodeSubscriptions.name = 'ManageNodeSubscriptions';

    function ManageNodeSubscriptions() {
      return ManageNodeSubscriptions.__super__.constructor.apply(this, arguments);
    }

    ManageNodeSubscriptions.prototype.iqType = function() {
      return 'set';
    };

    ManageNodeSubscriptions.prototype.pubsubChild = function() {
      var subscription, subscriptionsEl, _i, _len, _ref;
      subscriptionsEl = new xmpp.Element('subscriptions', {
        node: this.opts.node
      });
      _ref = this.opts.subscriptions;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        subscription = _ref[_i];
        subscriptionsEl.c('subscription', {
          jid: subscription.user,
          subscription: subscription.subscription
        });
      }
      return subscriptionsEl;
    };

    return ManageNodeSubscriptions;

  })(PubsubOwnerRequest);

  ManageNodeAffiliations = (function(_super) {

    __extends(ManageNodeAffiliations, _super);

    ManageNodeAffiliations.name = 'ManageNodeAffiliations';

    function ManageNodeAffiliations() {
      return ManageNodeAffiliations.__super__.constructor.apply(this, arguments);
    }

    ManageNodeAffiliations.prototype.iqType = function() {
      return 'set';
    };

    ManageNodeAffiliations.prototype.pubsubChild = function() {
      var affiliation, affiliationsEl, _i, _len, _ref;
      affiliationsEl = new xmpp.Element('affiliations', {
        node: this.opts.node
      });
      _ref = this.opts.affiliations;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        affiliation = _ref[_i];
        affiliationsEl.c('affiliation', {
          jid: affiliation.user,
          affiliation: affiliation.affiliation
        });
      }
      return affiliationsEl;
    };

    return ManageNodeAffiliations;

  })(PubsubOwnerRequest);

  RetrieveNodeConfiguration = (function(_super) {

    __extends(RetrieveNodeConfiguration, _super);

    RetrieveNodeConfiguration.name = 'RetrieveNodeConfiguration';

    function RetrieveNodeConfiguration() {
      return RetrieveNodeConfiguration.__super__.constructor.apply(this, arguments);
    }

    RetrieveNodeConfiguration.prototype.iqType = function() {
      return 'get';
    };

    RetrieveNodeConfiguration.prototype.pubsubChild = function() {
      return new xmpp.Element('configure', {
        node: this.opts.node
      });
    };

    RetrieveNodeConfiguration.prototype.decodeReplyEl = function(el) {
      var form, xEl, _base, _ref;
      if (el.is('configure', this.xmlns)) {
        xEl = el.getChild('x', NS.DATA);
        form = xEl && forms.fromXml(xEl);
        return (_ref = (_base = this.results).config) != null ? _ref : _base.config = form && forms.formToConfig(form);
      }
    };

    return RetrieveNodeConfiguration;

  })(PubsubOwnerRequest);

  ManageNodeConfiguration = (function(_super) {

    __extends(ManageNodeConfiguration, _super);

    ManageNodeConfiguration.name = 'ManageNodeConfiguration';

    function ManageNodeConfiguration() {
      return ManageNodeConfiguration.__super__.constructor.apply(this, arguments);
    }

    ManageNodeConfiguration.prototype.iqType = function() {
      return 'set';
    };

    ManageNodeConfiguration.prototype.pubsubChild = function() {
      return new xmpp.Element('configure', {
        node: this.opts.node
      }).cnode(forms.configToForm(this.opts.config, 'submit', NS.PUBSUB_NODE_CONFIG).toXml());
    };

    return ManageNodeConfiguration;

  })(PubsubOwnerRequest);

  AuthorizeSubscriber = (function() {

    AuthorizeSubscriber.name = 'AuthorizeSubscriber';

    function AuthorizeSubscriber(conn, opts, cb) {
      this.opts = opts;
      conn.send(this.makeStanza());
      cb();
    }

    AuthorizeSubscriber.prototype.makeStanza = function() {
      var form;
      form = new forms.Form('submit', NS.PUBSUB_SUBSCRIBE_AUTHORIZATION);
      form.addField('pubsub#node', 'text-single', 'Node', this.opts.node);
      form.addField('pubsub#subscriber_jid', 'jid-single', 'Subscriber Address', this.opts.user);
      form.addField('pubsub#allow', 'boolean', 'Allow?', (this.opts.allow ? 'true' : 'false'));
      form.addField('buddycloud#actor', 'jid-single', 'Authorizing actor', this.opts.actor);
      return new xmpp.Element('message', {
        type: 'headline',
        to: this.opts.jid
      }).cnode(form.toXml());
    };

    return AuthorizeSubscriber;

  })();

  REQUESTS = {
    'browse-node-info': exports.DiscoverInfo,
    'browse-info': exports.DiscoverInfo,
    'create-node': CreateNode,
    'publish-node-items': Publish,
    'subscribe-node': Subscribe,
    'unsubscribe-node': Unsubscribe,
    'retrieve-node-items': RetrieveItems,
    'retract-node-items': RetractItems,
    'retrieve-user-subscriptions': RetrieveUserSubscriptions,
    'retrieve-node-subscriptions': RetrieveNodeSubscriptions,
    'retrieve-node-affiliations': RetrieveNodeAffiliations,
    'manage-node-subscriptions': ManageNodeSubscriptions,
    'manage-node-affiliations': ManageNodeAffiliations,
    'retrieve-node-configuration': RetrieveNodeConfiguration,
    'manage-node-configuration': ManageNodeConfiguration,
    'confirm-subscriber-authorization': AuthorizeSubscriber
  };

  exports.byOperation = function(opName) {
    return REQUESTS[opName];
  };

}).call(this);
