// Generated by CoffeeScript 1.3.1
(function() {
  var DiscoInfoRequest, DiscoItemsRequest, EventEmitter, MessageArchiveRequest, NS, NotImplemented, PubsubAffiliationsRequest, PubsubCreateRequest, PubsubItemsRequest, PubsubOwnerGetAffiliationsRequest, PubsubOwnerGetConfigurationRequest, PubsubOwnerGetSubscriptionsRequest, PubsubOwnerRequest, PubsubOwnerSetAffiliationsRequest, PubsubOwnerSetConfigurationRequest, PubsubOwnerSetSubscriptionsRequest, PubsubPublishRequest, PubsubRequest, PubsubRetractRequest, PubsubSubscribeRequest, PubsubSubscriptionsRequest, PubsubUnsubscribeRequest, REQUESTS, RSM, RegisterGetRequest, RegisterRequest, RegisterSetRequest, Request, VersionGetRequest, errors, forms, logger, xmpp,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  logger = require('../logger').makeLogger('xmpp/pubsub_server');

  xmpp = require('node-xmpp');

  EventEmitter = require('events').EventEmitter;

  NS = require('./ns');

  forms = require('./forms');

  errors = require('../errors');

  RSM = require('./rsm');

  Request = (function() {

    Request.name = 'Request';

    function Request(stanza) {
      this.iq = stanza;
      this.sender = new xmpp.JID(stanza.attrs.from).bare().toString();
      this.fullSender = stanza.attrs.from;
      this.actor = this.sender;
      this.me = stanza.attrs.to;
    }

    Request.prototype.matches = function() {
      return false;
    };

    Request.prototype.reply = function(child) {
      return this.iq.reply(child);
    };

    Request.prototype.replyError = function(error) {
      return this.iq.replyError(error);
    };

    Request.prototype.callback = function(err, results) {
      var smallerResults;
      if (err) {
        return this.replyError(err);
      } else {
        try {
          return this.reply(results);
        } catch (e) {
          if (e.constructor === errors.MaxStanzaSizeExceeded && results.length > 0) {
            logger.warn("MaxStanzaSizeExceeded: " + results.length + " items");
            smallerResults = results != null ? results.slice(0, results.length - 1) : void 0;
            if (smallerResults.rsm == null) {
              smallerResults.rsm = results != null ? results.rsm : void 0;
            }
            return this.callback(err, smallerResults);
          } else {
            throw e;
          }
        }
      }
    };

    Request.prototype.operation = void 0;

    Request.prototype.setActor = function(childEl) {
      var actorEl, _ref;
      actorEl = childEl != null ? childEl.getChild("actor", NS.BUDDYCLOUD_V1) : void 0;
      if (actorEl != null) {
        this.actor = actorEl.getText();
        return (_ref = this.actorType) != null ? _ref : this.actorType = actorEl.attrs.type;
      }
    };

    Request.prototype.setRSM = function(childEl) {
      var rsmEl;
      rsmEl = childEl != null ? childEl.getChild('set', NS.RSM) : void 0;
      return this.rsm = RSM.fromXml(rsmEl);
    };

    return Request;

  })();

  NotImplemented = (function(_super) {

    __extends(NotImplemented, _super);

    NotImplemented.name = 'NotImplemented';

    function NotImplemented() {
      return NotImplemented.__super__.constructor.apply(this, arguments);
    }

    NotImplemented.prototype.matches = function() {
      return true;
    };

    NotImplemented.prototype.reply = function() {
      return this.replyError(new errors.FeatureNotImplemented("Feature not implemented"));
    };

    return NotImplemented;

  })(Request);

  /*
  # XEP-0092: Software Version
  */


  VersionGetRequest = (function(_super) {

    __extends(VersionGetRequest, _super);

    VersionGetRequest.name = 'VersionGetRequest';

    function VersionGetRequest() {
      return VersionGetRequest.__super__.constructor.apply(this, arguments);
    }

    VersionGetRequest.prototype.matches = function() {
      return this.iq.attrs.type === 'get' && (this.iq.getChild("query", NS.VERSION) != null);
    };

    VersionGetRequest.prototype.reply = function(result) {
      var queryEl;
      queryEl = new xmpp.Element("query", {
        xmlns: NS.VERSION
      });
      if (result.name) {
        queryEl.c('name').t(result.name);
      }
      if (result.version) {
        queryEl.c('version').t(result.version);
      }
      if (result.os) {
        queryEl.c('os').t(result.os);
      }
      return VersionGetRequest.__super__.reply.call(this, queryEl);
    };

    VersionGetRequest.prototype.operation = 'get-version';

    return VersionGetRequest;

  })(Request);

  /*
  # XEP-0030: Service Discovery
  */


  DiscoInfoRequest = (function(_super) {

    __extends(DiscoInfoRequest, _super);

    DiscoInfoRequest.name = 'DiscoInfoRequest';

    function DiscoInfoRequest(stanza) {
      var _ref;
      DiscoInfoRequest.__super__.constructor.apply(this, arguments);
      this.discoInfoEl = this.iq.getChild("query", NS.DISCO_INFO);
      this.node = (_ref = this.discoInfoEl) != null ? _ref.attrs.node : void 0;
      if (this.node) {
        this.operation = 'browse-node-info';
      } else {
        this.operation = 'browse-info';
      }
    }

    DiscoInfoRequest.prototype.matches = function() {
      return this.iq.attrs.type === 'get' && (this.discoInfoEl != null);
    };

    DiscoInfoRequest.prototype.reply = function(result) {
      var feature, identity, queryEl, _i, _j, _len, _len1, _ref, _ref1;
      queryEl = new xmpp.Element("query", {
        xmlns: NS.DISCO_INFO
      });
      if ((result != null ? result.node : void 0) != null) {
        queryEl.attrs.node = result.node;
      }
      _ref = result.identities;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        identity = _ref[_i];
        queryEl.c("identity", {
          category: identity.category,
          type: identity.type,
          name: identity.name
        });
      }
      _ref1 = result.features;
      for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
        feature = _ref1[_j];
        queryEl.c("feature", {
          "var": feature
        });
      }
      if (result.config != null) {
        queryEl.cnode(forms.configToForm(result.config, 'result', NS.PUBSUB_META_DATA).toXml());
      }
      return DiscoInfoRequest.__super__.reply.call(this, queryEl);
    };

    return DiscoInfoRequest;

  })(Request);

  DiscoItemsRequest = (function(_super) {

    __extends(DiscoItemsRequest, _super);

    DiscoItemsRequest.name = 'DiscoItemsRequest';

    function DiscoItemsRequest(stanza) {
      var _ref;
      DiscoItemsRequest.__super__.constructor.apply(this, arguments);
      this.discoItemsEl = this.iq.getChild("query", NS.DISCO_ITEMS);
      this.node = (_ref = this.discoItemsEl) != null ? _ref.attrs.node : void 0;
      if (this.node == null) {
        this.operation = 'browse-nodes';
      } else if (this.node === "/top-followed-nodes") {
        this.operation = 'browse-top-followed-nodes';
        delete this.node;
      } else if (this.node === "/top-published-nodes") {
        this.operation = 'browse-top-published-nodes';
        delete this.node;
      } else {
        this.operation = 'browse-node-items';
      }
      this.setRSM(this.discoItemsEl);
    }

    DiscoItemsRequest.prototype.matches = function() {
      return this.iq.attrs.type === 'get' && (this.discoItemsEl != null);
    };

    DiscoItemsRequest.prototype.reply = function(results) {
      var attrs, item, queryEl, _i, _len;
      logger.debug({
        'DiscoItemsRequest.reply': results
      });
      queryEl = new xmpp.Element("query", {
        xmlns: NS.DISCO_ITEMS
      });
      if (results != null ? results.node : void 0) {
        queryEl.attrs.node = results.node;
      }
      for (_i = 0, _len = results.length; _i < _len; _i++) {
        item = results[_i];
        attrs = {};
        if (attrs.jid == null) {
          attrs.jid = item.jid;
        }
        if (attrs.name == null) {
          attrs.name = item.name;
        }
        if (attrs.node == null) {
          attrs.node = item.node;
        }
        queryEl.c("item", attrs);
      }
      if (results.rsm) {
        if (this.operation === 'browse-node-items') {
          results.rsm.setReplyInfo(results, 'name');
        } else {
          results.rsm.setReplyInfo(results, 'node');
        }
        results.rsm.rmRequestInfo();
        queryEl.cnode(results.rsm.toXml());
      }
      return DiscoItemsRequest.__super__.reply.call(this, queryEl);
    };

    return DiscoItemsRequest;

  })(Request);

  RegisterRequest = (function(_super) {

    __extends(RegisterRequest, _super);

    RegisterRequest.name = 'RegisterRequest';

    function RegisterRequest(stanza) {
      RegisterRequest.__super__.constructor.apply(this, arguments);
      this.registerEl = this.iq.getChild("query", NS.REGISTER);
    }

    RegisterRequest.prototype.matches = function() {
      return this.registerEl;
    };

    return RegisterRequest;

  })(Request);

  RegisterGetRequest = (function(_super) {

    __extends(RegisterGetRequest, _super);

    RegisterGetRequest.name = 'RegisterGetRequest';

    function RegisterGetRequest() {
      return RegisterGetRequest.__super__.constructor.apply(this, arguments);
    }

    RegisterGetRequest.prototype.matches = function() {
      return RegisterGetRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get';
    };

    RegisterGetRequest.prototype.reply = function() {
      return RegisterGetRequest.__super__.reply.call(this, new xmpp.Element("query", {
        xmlns: NS.REGISTER
      }).c("instructions").t("Simply register here"));
    };

    return RegisterGetRequest;

  })(RegisterRequest);

  RegisterSetRequest = (function(_super) {

    __extends(RegisterSetRequest, _super);

    RegisterSetRequest.name = 'RegisterSetRequest';

    function RegisterSetRequest() {
      return RegisterSetRequest.__super__.constructor.apply(this, arguments);
    }

    RegisterSetRequest.prototype.matches = function() {
      return RegisterSetRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set';
    };

    RegisterSetRequest.prototype.operation = 'register-user';

    RegisterSetRequest.prototype.subscriptionRequired = true;

    RegisterSetRequest.prototype.writes = true;

    return RegisterSetRequest;

  })(RegisterRequest);

  /*
  # XEP-0060: Publish-Subscribe
  */


  PubsubRequest = (function(_super) {

    __extends(PubsubRequest, _super);

    PubsubRequest.name = 'PubsubRequest';

    PubsubRequest.prototype.xmlns = NS.PUBSUB;

    function PubsubRequest(stanza) {
      PubsubRequest.__super__.constructor.apply(this, arguments);
      this.pubsubEl = this.iq.getChild("pubsub", this.xmlns);
      if (this.pubsubEl) {
        this.setActor(this.pubsubEl);
        this.setRSM(this.pubsubEl);
      }
    }

    PubsubRequest.prototype.matches = function() {
      return (this.iq.attrs.type === 'get' || this.iq.attrs.type === 'set') && (this.pubsubEl != null);
    };

    PubsubRequest.prototype.reply = function(child, rsm) {
      var pubsubEl;
      if ((child != null ? child.children : void 0) != null) {
        pubsubEl = new xmpp.Element("pubsub", {
          xmlns: this.xmlns
        });
        pubsubEl.cnode(child);
        if (rsm) {
          rsm.rmRequestInfo();
          pubsubEl.cnode(rsm.toXml());
        }
        return PubsubRequest.__super__.reply.call(this, pubsubEl);
      } else {
        return PubsubRequest.__super__.reply.call(this);
      }
    };

    return PubsubRequest;

  })(Request);

  PubsubOwnerRequest = (function(_super) {

    __extends(PubsubOwnerRequest, _super);

    PubsubOwnerRequest.name = 'PubsubOwnerRequest';

    function PubsubOwnerRequest() {
      return PubsubOwnerRequest.__super__.constructor.apply(this, arguments);
    }

    PubsubOwnerRequest.prototype.xmlns = NS.PUBSUB_OWNER;

    return PubsubOwnerRequest;

  })(PubsubRequest);

  PubsubCreateRequest = (function(_super) {

    __extends(PubsubCreateRequest, _super);

    PubsubCreateRequest.name = 'PubsubCreateRequest';

    function PubsubCreateRequest(stanza) {
      var configureEl, _ref, _ref1, _ref2,
        _this = this;
      PubsubCreateRequest.__super__.constructor.apply(this, arguments);
      this.createEl = (_ref = this.pubsubEl) != null ? _ref.getChild("create") : void 0;
      this.node = (_ref1 = this.createEl) != null ? _ref1.attrs.node : void 0;
      configureEl = (_ref2 = this.pubsubEl) != null ? _ref2.getChild("configure") : void 0;
      if (configureEl) {
        this.config = {};
        if (configureEl != null) {
          configureEl.getChildren("x", NS.DATA).forEach(function(formEl) {
            var form;
            form = forms.fromXml(formEl);
            return _this.config = forms.formToConfig(form) || _this.config;
          });
        }
      }
    }

    PubsubCreateRequest.prototype.matches = function() {
      return PubsubCreateRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubCreateRequest.prototype.operation = 'create-node';

    PubsubCreateRequest.prototype.writes = true;

    return PubsubCreateRequest;

  })(PubsubRequest);

  PubsubSubscribeRequest = (function(_super) {

    __extends(PubsubSubscribeRequest, _super);

    PubsubSubscribeRequest.name = 'PubsubSubscribeRequest';

    function PubsubSubscribeRequest(stanza) {
      var _ref, _ref1;
      PubsubSubscribeRequest.__super__.constructor.apply(this, arguments);
      this.subscribeEl = (_ref = this.pubsubEl) != null ? _ref.getChild("subscribe") : void 0;
      this.node = (_ref1 = this.subscribeEl) != null ? _ref1.attrs.node : void 0;
    }

    PubsubSubscribeRequest.prototype.matches = function() {
      return PubsubSubscribeRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubSubscribeRequest.prototype.reply = function(result) {
      var attrs;
      attrs = {
        node: this.node
      };
      if (attrs.jid == null) {
        attrs.jid = result != null ? result.user : void 0;
      }
      if (attrs.subscription == null) {
        attrs.subscription = result != null ? result.subscription : void 0;
      }
      return PubsubSubscribeRequest.__super__.reply.call(this, new xmpp.Element("subscription", attrs));
    };

    PubsubSubscribeRequest.prototype.operation = 'subscribe-node';

    PubsubSubscribeRequest.prototype.writes = true;

    return PubsubSubscribeRequest;

  })(PubsubRequest);

  PubsubUnsubscribeRequest = (function(_super) {

    __extends(PubsubUnsubscribeRequest, _super);

    PubsubUnsubscribeRequest.name = 'PubsubUnsubscribeRequest';

    function PubsubUnsubscribeRequest(stanza) {
      var _ref, _ref1;
      PubsubUnsubscribeRequest.__super__.constructor.apply(this, arguments);
      this.unsubscribeEl = (_ref = this.pubsubEl) != null ? _ref.getChild("unsubscribe") : void 0;
      this.node = (_ref1 = this.unsubscribeEl) != null ? _ref1.attrs.node : void 0;
    }

    PubsubUnsubscribeRequest.prototype.matches = function() {
      return PubsubUnsubscribeRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubUnsubscribeRequest.prototype.operation = 'unsubscribe-node';

    PubsubUnsubscribeRequest.prototype.writes = true;

    return PubsubUnsubscribeRequest;

  })(PubsubRequest);

  PubsubPublishRequest = (function(_super) {

    __extends(PubsubPublishRequest, _super);

    PubsubPublishRequest.name = 'PubsubPublishRequest';

    function PubsubPublishRequest(stanza) {
      var item, itemEl, _i, _len, _ref, _ref1;
      PubsubPublishRequest.__super__.constructor.apply(this, arguments);
      this.publishEl = (_ref = this.pubsubEl) != null ? _ref.getChild("publish") : void 0;
      this.items = [];
      if (this.publishEl) {
        this.node = this.publishEl.attrs.node;
        _ref1 = this.publishEl.getChildren("item");
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          itemEl = _ref1[_i];
          item = {
            el: itemEl.children.filter(function(itemEl) {
              return itemEl.hasOwnProperty('children');
            })[0]
          };
          if (itemEl.attrs.id) {
            item.id = itemEl.attrs.id;
          }
          this.items.push(item);
        }
      }
    }

    PubsubPublishRequest.prototype.matches = function() {
      return PubsubPublishRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubPublishRequest.prototype.operation = 'publish-node-items';

    PubsubPublishRequest.prototype.reply = function(ids) {
      var id, publishEl, _i, _len;
      if (ids != null) {
        publishEl = new xmpp.Element('publish', {
          node: this.node
        });
        for (_i = 0, _len = ids.length; _i < _len; _i++) {
          id = ids[_i];
          publishEl.c('item', {
            id: id
          });
        }
        return PubsubPublishRequest.__super__.reply.call(this, publishEl);
      } else {
        return PubsubPublishRequest.__super__.reply.call(this);
      }
    };

    PubsubPublishRequest.prototype.writes = true;

    return PubsubPublishRequest;

  })(PubsubRequest);

  PubsubRetractRequest = (function(_super) {

    __extends(PubsubRetractRequest, _super);

    PubsubRetractRequest.name = 'PubsubRetractRequest';

    function PubsubRetractRequest(stanza) {
      var itemEl, _i, _len, _ref, _ref1;
      PubsubRetractRequest.__super__.constructor.apply(this, arguments);
      this.retractEl = (_ref = this.pubsubEl) != null ? _ref.getChild("retract") : void 0;
      this.items = [];
      if (this.retractEl) {
        this.node = this.retractEl.attrs.node;
        _ref1 = this.retractEl.getChildren("item");
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          itemEl = _ref1[_i];
          if (itemEl.attrs.id) {
            this.items.push(itemEl.attrs.id);
          }
        }
      }
    }

    PubsubRetractRequest.prototype.matches = function() {
      return PubsubRetractRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubRetractRequest.prototype.operation = 'retract-node-items';

    PubsubRetractRequest.prototype.writes = true;

    return PubsubRetractRequest;

  })(PubsubRequest);

  PubsubItemsRequest = (function(_super) {

    __extends(PubsubItemsRequest, _super);

    PubsubItemsRequest.name = 'PubsubItemsRequest';

    function PubsubItemsRequest(stanza) {
      var itemEls, _ref, _ref1, _ref2, _ref3;
      PubsubItemsRequest.__super__.constructor.apply(this, arguments);
      this.itemsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("items") : void 0;
      if (((_ref1 = (itemEls = (_ref2 = this.itemsEl) != null ? _ref2.getChildren("item") : void 0)) != null ? _ref1.length : void 0) > 0) {
        this.itemIds = itemEls.map(function(itemEl) {
          return itemEl.attrs.id;
        });
      }
      this.node = (_ref3 = this.itemsEl) != null ? _ref3.attrs.node : void 0;
    }

    PubsubItemsRequest.prototype.matches = function() {
      return PubsubItemsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.node;
    };

    PubsubItemsRequest.prototype.reply = function(items) {
      var item, itemEl, itemsEl, _i, _len;
      items.rsm.setReplyInfo(items, 'id');
      itemsEl = new xmpp.Element("items", {
        node: items.node
      });
      for (_i = 0, _len = items.length; _i < _len; _i++) {
        item = items[_i];
        itemEl = itemsEl.c("item", {
          id: item.id
        });
        itemEl.cnode(item.el);
      }
      return PubsubItemsRequest.__super__.reply.call(this, itemsEl, items.rsm);
    };

    PubsubItemsRequest.prototype.operation = 'retrieve-node-items';

    return PubsubItemsRequest;

  })(PubsubRequest);

  PubsubSubscriptionsRequest = (function(_super) {

    __extends(PubsubSubscriptionsRequest, _super);

    PubsubSubscriptionsRequest.name = 'PubsubSubscriptionsRequest';

    function PubsubSubscriptionsRequest(stanza) {
      var _ref;
      PubsubSubscriptionsRequest.__super__.constructor.apply(this, arguments);
      this.subscriptionsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("subscriptions") : void 0;
    }

    PubsubSubscriptionsRequest.prototype.matches = function() {
      return PubsubSubscriptionsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.subscriptionsEl;
    };

    PubsubSubscriptionsRequest.prototype.reply = function(nodes) {
      var attrs, node, subscriptionsEl, _i, _len;
      nodes.rsm.setReplyInfo(nodes, 'node');
      subscriptionsEl = new xmpp.Element("subscriptions");
      for (_i = 0, _len = nodes.length; _i < _len; _i++) {
        node = nodes[_i];
        attrs = {
          node: node.node,
          subscription: node.subscription
        };
        if (node.jid) {
          attrs.jid = node.jid;
        }
        subscriptionsEl.c("subscription", attrs);
      }
      return PubsubSubscriptionsRequest.__super__.reply.call(this, subscriptionsEl, nodes.rsm);
    };

    PubsubSubscriptionsRequest.prototype.operation = 'retrieve-user-subscriptions';

    return PubsubSubscriptionsRequest;

  })(PubsubRequest);

  PubsubAffiliationsRequest = (function(_super) {

    __extends(PubsubAffiliationsRequest, _super);

    PubsubAffiliationsRequest.name = 'PubsubAffiliationsRequest';

    function PubsubAffiliationsRequest(stanza) {
      var _ref;
      PubsubAffiliationsRequest.__super__.constructor.apply(this, arguments);
      this.affiliationsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("affiliations") : void 0;
    }

    PubsubAffiliationsRequest.prototype.matches = function() {
      return PubsubAffiliationsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.affiliationsEl;
    };

    PubsubAffiliationsRequest.prototype.reply = function(nodes) {
      var affiliationsEl, attrs, node, _i, _len;
      nodes.rsm.setReplyInfo(nodes, 'node');
      affiliationsEl = new xmpp.Element("affiliations");
      for (_i = 0, _len = nodes.length; _i < _len; _i++) {
        node = nodes[_i];
        attrs = {
          node: node.node,
          affiliation: node.affiliation
        };
        if (node.jid) {
          attrs.jid = node.jid;
        }
        affiliationsEl.c("affiliation", attrs);
      }
      return PubsubAffiliationsRequest.__super__.reply.call(this, affiliationsEl, nodes.rsm);
    };

    PubsubAffiliationsRequest.prototype.operation = 'retrieve-user-affiliations';

    return PubsubAffiliationsRequest;

  })(PubsubRequest);

  PubsubOwnerGetSubscriptionsRequest = (function(_super) {

    __extends(PubsubOwnerGetSubscriptionsRequest, _super);

    PubsubOwnerGetSubscriptionsRequest.name = 'PubsubOwnerGetSubscriptionsRequest';

    function PubsubOwnerGetSubscriptionsRequest(stanza) {
      var _ref, _ref1;
      PubsubOwnerGetSubscriptionsRequest.__super__.constructor.apply(this, arguments);
      this.subscriptionsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("subscriptions") : void 0;
      this.node = (_ref1 = this.subscriptionsEl) != null ? _ref1.attrs.node : void 0;
    }

    PubsubOwnerGetSubscriptionsRequest.prototype.matches = function() {
      return PubsubOwnerGetSubscriptionsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.node;
    };

    PubsubOwnerGetSubscriptionsRequest.prototype.reply = function(subscriptions) {
      var subscription, subscriptionsEl, _i, _len;
      subscriptions.rsm.setReplyInfo(subscriptions, 'user');
      subscriptionsEl = new xmpp.Element("subscriptions");
      for (_i = 0, _len = subscriptions.length; _i < _len; _i++) {
        subscription = subscriptions[_i];
        subscriptionsEl.c('subscription', {
          jid: subscription.user,
          subscription: subscription.subscription
        });
      }
      return PubsubOwnerGetSubscriptionsRequest.__super__.reply.call(this, subscriptionsEl, subscriptions.rsm);
    };

    PubsubOwnerGetSubscriptionsRequest.prototype.operation = 'retrieve-node-subscriptions';

    return PubsubOwnerGetSubscriptionsRequest;

  })(PubsubOwnerRequest);

  PubsubOwnerSetSubscriptionsRequest = (function(_super) {

    __extends(PubsubOwnerSetSubscriptionsRequest, _super);

    PubsubOwnerSetSubscriptionsRequest.name = 'PubsubOwnerSetSubscriptionsRequest';

    function PubsubOwnerSetSubscriptionsRequest(stanza) {
      var _ref;
      PubsubOwnerSetSubscriptionsRequest.__super__.constructor.apply(this, arguments);
      this.subscriptionsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("subscriptions") : void 0;
      this.subscriptions = [];
      if (this.subscriptionsEl) {
        this.node = this.subscriptionsEl.attrs.node;
        this.subscriptions = this.subscriptionsEl.getChildren("subscription").map(function(subscriptionEl) {
          return {
            user: subscriptionEl.attrs.jid,
            subscription: subscriptionEl.attrs.subscription
          };
        });
      }
    }

    PubsubOwnerSetSubscriptionsRequest.prototype.matches = function() {
      return PubsubOwnerSetSubscriptionsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.subscriptionsEl;
    };

    PubsubOwnerSetSubscriptionsRequest.prototype.operation = 'manage-node-subscriptions';

    PubsubOwnerSetSubscriptionsRequest.prototype.writes = true;

    return PubsubOwnerSetSubscriptionsRequest;

  })(PubsubOwnerRequest);

  PubsubOwnerGetAffiliationsRequest = (function(_super) {

    __extends(PubsubOwnerGetAffiliationsRequest, _super);

    PubsubOwnerGetAffiliationsRequest.name = 'PubsubOwnerGetAffiliationsRequest';

    function PubsubOwnerGetAffiliationsRequest(stanza) {
      var _ref, _ref1;
      PubsubOwnerGetAffiliationsRequest.__super__.constructor.apply(this, arguments);
      this.affiliationsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("affiliations") : void 0;
      this.node = (_ref1 = this.affiliationsEl) != null ? _ref1.attrs.node : void 0;
    }

    PubsubOwnerGetAffiliationsRequest.prototype.matches = function() {
      return PubsubOwnerGetAffiliationsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.affiliationsEl;
    };

    PubsubOwnerGetAffiliationsRequest.prototype.reply = function(affiliations) {
      var affiliation, affiliationsEl, _i, _len;
      affiliations.rsm.setReplyInfo(affiliations, 'user');
      affiliationsEl = new xmpp.Element("affiliations");
      for (_i = 0, _len = affiliations.length; _i < _len; _i++) {
        affiliation = affiliations[_i];
        affiliationsEl.c('affiliation', {
          jid: affiliation.user,
          affiliation: affiliation.affiliation
        });
      }
      return PubsubOwnerGetAffiliationsRequest.__super__.reply.call(this, affiliationsEl, affiliations.rsm);
    };

    PubsubOwnerGetAffiliationsRequest.prototype.operation = 'retrieve-node-affiliations';

    return PubsubOwnerGetAffiliationsRequest;

  })(PubsubOwnerRequest);

  PubsubOwnerSetAffiliationsRequest = (function(_super) {

    __extends(PubsubOwnerSetAffiliationsRequest, _super);

    PubsubOwnerSetAffiliationsRequest.name = 'PubsubOwnerSetAffiliationsRequest';

    function PubsubOwnerSetAffiliationsRequest(stanza) {
      var _ref, _ref1;
      PubsubOwnerSetAffiliationsRequest.__super__.constructor.apply(this, arguments);
      this.affiliationsEl = (_ref = this.pubsubEl) != null ? _ref.getChild("affiliations") : void 0;
      this.affiliations = [];
      if (this.affiliationsEl) {
        this.node = this.affiliationsEl.attrs.node;
        this.affiliations = (_ref1 = this.affiliationsEl) != null ? _ref1.getChildren("affiliation").map(function(affiliationEl) {
          return {
            user: affiliationEl.attrs.jid,
            affiliation: affiliationEl.attrs.affiliation
          };
        }) : void 0;
      }
    }

    PubsubOwnerSetAffiliationsRequest.prototype.matches = function() {
      return PubsubOwnerSetAffiliationsRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.affiliationsEl;
    };

    PubsubOwnerSetAffiliationsRequest.prototype.operation = 'manage-node-affiliations';

    PubsubOwnerSetAffiliationsRequest.prototype.writes = true;

    return PubsubOwnerSetAffiliationsRequest;

  })(PubsubOwnerRequest);

  PubsubOwnerGetConfigurationRequest = (function(_super) {

    __extends(PubsubOwnerGetConfigurationRequest, _super);

    PubsubOwnerGetConfigurationRequest.name = 'PubsubOwnerGetConfigurationRequest';

    function PubsubOwnerGetConfigurationRequest(stanza) {
      var _ref, _ref1, _ref2;
      PubsubOwnerGetConfigurationRequest.__super__.constructor.apply(this, arguments);
      this.configureEl = (_ref = this.pubsubEl) != null ? _ref.getChild("configure") : void 0;
      this.node = (_ref1 = this.configureEl) != null ? (_ref2 = _ref1.attrs) != null ? _ref2.node : void 0 : void 0;
    }

    PubsubOwnerGetConfigurationRequest.prototype.matches = function() {
      return PubsubOwnerGetConfigurationRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'get' && this.node;
    };

    PubsubOwnerGetConfigurationRequest.prototype.operation = 'retrieve-node-configuration';

    PubsubOwnerGetConfigurationRequest.prototype.reply = function(result) {
      var configureEl;
      configureEl = new xmpp.Element("configure", {
        node: this.node
      });
      if (result.config != null) {
        configureEl.cnode(forms.configToForm(result.config, 'result', NS.PUBSUB_NODE_CONFIG).toXml());
      }
      return PubsubOwnerGetConfigurationRequest.__super__.reply.call(this, configureEl);
    };

    return PubsubOwnerGetConfigurationRequest;

  })(PubsubOwnerRequest);

  PubsubOwnerSetConfigurationRequest = (function(_super) {

    __extends(PubsubOwnerSetConfigurationRequest, _super);

    PubsubOwnerSetConfigurationRequest.name = 'PubsubOwnerSetConfigurationRequest';

    function PubsubOwnerSetConfigurationRequest(stanza) {
      var _ref, _ref1, _ref2, _ref3,
        _this = this;
      PubsubOwnerSetConfigurationRequest.__super__.constructor.apply(this, arguments);
      this.configureEl = (_ref = this.pubsubEl) != null ? _ref.getChild("configure") : void 0;
      this.node = (_ref1 = this.configureEl) != null ? (_ref2 = _ref1.attrs) != null ? _ref2.node : void 0 : void 0;
      this.config = {};
      if ((_ref3 = this.configureEl) != null) {
        _ref3.getChildren("x", NS.DATA).forEach(function(formEl) {
          var form;
          form = forms.fromXml(formEl);
          return _this.config = forms.formToConfig(form) || _this.config;
        });
      }
    }

    PubsubOwnerSetConfigurationRequest.prototype.matches = function() {
      return PubsubOwnerSetConfigurationRequest.__super__.matches.apply(this, arguments) && this.iq.attrs.type === 'set' && this.node;
    };

    PubsubOwnerSetConfigurationRequest.prototype.operation = 'manage-node-configuration';

    PubsubOwnerSetConfigurationRequest.prototype.writes = true;

    return PubsubOwnerSetConfigurationRequest;

  })(PubsubOwnerRequest);

  MessageArchiveRequest = (function(_super) {

    __extends(MessageArchiveRequest, _super);

    MessageArchiveRequest.name = 'MessageArchiveRequest';

    function MessageArchiveRequest(stanza) {
      var _ref, _ref1, _ref2, _ref3;
      MessageArchiveRequest.__super__.constructor.apply(this, arguments);
      this.mamEl = this.iq.getChild("query", NS.MAM);
      this.start = (_ref = this.mamEl) != null ? (_ref1 = _ref.attrs) != null ? _ref1.start : void 0 : void 0;
      this.end = (_ref2 = this.mamEl) != null ? (_ref3 = _ref2.attrs) != null ? _ref3.end : void 0 : void 0;
    }

    MessageArchiveRequest.prototype.matches = function() {
      return this.iq.attrs.type === 'get' && (this.mamEl != null);
    };

    MessageArchiveRequest.prototype.operation = 'replay-archive';

    return MessageArchiveRequest;

  })(Request);

  REQUESTS = [VersionGetRequest, DiscoInfoRequest, DiscoItemsRequest, RegisterGetRequest, RegisterSetRequest, PubsubCreateRequest, PubsubSubscribeRequest, PubsubUnsubscribeRequest, PubsubPublishRequest, PubsubRetractRequest, PubsubItemsRequest, PubsubSubscriptionsRequest, PubsubAffiliationsRequest, PubsubOwnerGetSubscriptionsRequest, PubsubOwnerSetSubscriptionsRequest, PubsubOwnerGetAffiliationsRequest, PubsubOwnerSetAffiliationsRequest, PubsubOwnerGetConfigurationRequest, PubsubOwnerSetConfigurationRequest, MessageArchiveRequest, NotImplemented];

  exports.PubsubServer = (function(_super) {

    __extends(PubsubServer, _super);

    PubsubServer.name = 'PubsubServer';

    function PubsubServer(conn) {
      var _this = this;
      this.conn = conn;
      this.conn.on('iqRequest', function(stanza) {
        var bareJid, request;
        request = _this.makeRequest(stanza);
        _this.emit('request', request);
        if (request.subscriptionRequired) {
          bareJid = new xmpp.JID(stanza.attrs.from).bare().toString();
          return _this.conn.subscribePresence(bareJid);
        }
      });
    }

    PubsubServer.prototype.makeRequest = function(stanza) {
      var r, result, _i, _len;
      result = null;
      for (_i = 0, _len = REQUESTS.length; _i < _len; _i++) {
        r = REQUESTS[_i];
        result = new r(stanza);
        if (result.matches()) {
          logger.trace('found subrequest', r.name);
          break;
        } else {
          result = null;
        }
      }
      return result;
    };

    return PubsubServer;

  })(EventEmitter);

}).call(this);
