// Generated by CoffeeScript 1.3.1
(function() {
  var NS, xmpp;

  xmpp = require('node-xmpp');

  NS = require('./ns');

  exports.RSM = (function() {

    RSM.name = 'RSM';

    function RSM() {}

    RSM.prototype.cropResults = function(results, key) {
      var afterIdx, beforeIdx, indexOf;
      if (key) {
        indexOf = function(id) {
          var i, result, _i, _len;
          i = 0;
          for (_i = 0, _len = results.length; _i < _len; _i++) {
            result = results[_i];
            if (result[key] === id) {
              return i;
            }
            i++;
          }
          return -1;
        };
      } else {
        indexOf = function(id) {
          return results.indexOf(id);
        };
      }
      this.firstIndex = 0;
      this.count = results.length;
      if (this.after) {
        afterIdx = indexOf(this.after);
        if (afterIdx >= 0) {
          results = results.slice(afterIdx + 1);
          this.firstIndex = afterIdx + 1;
        }
      }
      if (this.before) {
        beforeIdx = indexOf(this.before);
        if (beforeIdx >= 0) {
          results = results.slice(0, beforeIdx);
        }
      }
      this.max = Math.min(100, this.max || 100);
      if ('before' in this) {
        results = results.slice(Math.max(0, results.length - this.max), results.length);
        this.firstIndex = this.count - results.length;
      } else {
        results = results.slice(0, Math.min(this.max, results.length));
      }
      results.rsm = this;
      return results;
    };

    RSM.prototype.setReplyInfo = function(results, key) {
      var getKey;
      if (this.fromRemote) {
        return;
      }
      delete this.first;
      delete this.last;
      if (results.length > 0) {
        if (key) {
          getKey = function(result) {
            return result[key];
          };
        } else {
          getKey = function(result) {
            return result;
          };
        }
        this.first = getKey(results[0]);
        return this.last = getKey(results[results.length - 1]);
      }
    };

    RSM.prototype.rmRequestInfo = function() {
      delete this.max;
      delete this.after;
      return delete this.before;
    };

    RSM.prototype.toXml = function() {
      var el, firstEl;
      el = new xmpp.Element('set', {
        xmlns: NS.RSM
      });
      if ('max' in this) {
        el.c('max').t("" + this.max);
      }
      if ('index' in this) {
        el.c('index').t("" + this.index);
      }
      if (this.after) {
        el.c('after').t(this.after);
      }
      if (this.before) {
        el.c('before').t(this.before);
      }
      if (this.first) {
        firstEl = el.c('first');
        firstEl.t(this.first);
        if ('firstIndex' in this) {
          firstEl.attrs.index = "" + this.firstIndex;
        }
      }
      if (this.last) {
        el.c('last').t(this.last);
      }
      if ('count' in this) {
        el.c('count').t("" + this.count);
      }
      return el;
    };

    return RSM;

  })();

  exports.fromXml = function(el, fromRemote) {
    var afterEl, beforeEl, count, firstEl, index, max, rsm, _ref;
    this.fromRemote = fromRemote;
    rsm = new exports.RSM();
    if (!el) {
      return rsm;
    }
    if ((max = el.getChildText('max'))) {
      rsm.max = parseInt(max, 10);
    }
    if ((index = el.getChildText('index'))) {
      rsm.index = parseInt(index, 10);
    }
    if ((afterEl = el.getChild('after')) != null) {
      rsm.after = afterEl.getText();
    }
    if ((beforeEl = el.getChild('before')) != null) {
      rsm.before = beforeEl.getText();
    }
    if ((firstEl = el.getChild('first'))) {
      rsm.first = firstEl.getText();
      if ('index' in firstEl.attrs) {
        rsm.firstIndex = parseInt(firstEl.attrs.index, 10);
      }
    }
    if (rsm.last == null) {
      rsm.last = el.getChildText('last');
    }
    if ((count = (_ref = el.getChild('count')) != null ? _ref.getText() : void 0)) {
      rsm.count = parseInt(count, 10);
    }
    return rsm;
  };

}).call(this);
